#!/usr/local/tcl-tk/bin/wish
#
#  wwgetall.tcl
#    By Yoshioka Tsuneo
#    Welcome E-Mail to (tsuneo-y@is.aist-nara.ac.jp/QWF00133@nifty.ne.jp)
#    Please use this file like Public Domain Software.
#
# HOW TO USE
#     UNIX
#        1. install tcl8.0.3.tar.gz/tk8.0.3.tar.gz
#        from http://infonet.aist-nara.ac.jp/~tsuneo-y/soft/wwgetall/
#        or other site.
#        2. re-write first line of this file(wwgetall.tcl) to correct path
#        that exists "wish" program.
#     WINDOWS95/NT
#        1. download and install tcl803.exe
#        from http://infonet.aist-nara.ac.jp/~tsuneo-y/soft/wwgetall/
#        or other site.
#        2. re-write a line of
#         set cmd_wwgetall "wwgetall.pl"
#        to
#         set cmd_wwgetall "C:/perl/bin/perl C:/install/wwgetall/wwgetall.tcl
#        .

# Program File Name
set cmd_wwgetall "wwgetall.pl"

frame .url
label .url.inputlabel -text "URL:"
entry .url.inputentry -textvariable url
pack .url.inputlabel .url.inputentry -in .url -side left

frame .proxy
label .proxy.inputlabel -text "proxy:"
entry .proxy.inputentry -textvariable proxy
pack .proxy.inputlabel .proxy.inputentry -in .proxy -side left

frame .rootdir
label .rootdir.inputlabel -text "rootdir:"
entry .rootdir.inputentry -textvariable rootdir
pack .rootdir.inputlabel .rootdir.inputentry -in .rootdir -side left

frame .log
label .log.inputlabel -text "log:"
entry .log.inputentry -textvariable log
set log "wwgetall.log"
pack .log.inputlabel .log.inputentry -in .log -side left

frame .connection
label .connection.inputlabel -text "connection:"
entry .connection.inputentry -textvariable connection
set connection "5"
pack .connection.inputlabel .connection.inputentry -in .connection -side left

frame .auth
label .auth.inputlabel -text "auth:"
entry .auth.inputentry -textvariable auth
pack .auth.inputlabel .auth.inputentry -in .auth -side left

frame .match
label .match.inputlabel -text "match:"
entry .match.inputentry -textvariable match
pack .match.inputlabel .match.inputentry -in .match -side left

frame .type
label .type.label -text "type:"
checkbutton .type.all -variable alltype -text "all" -onvalue 1 -offvalue 0
checkbutton .type.htmlonly -variable htmlonly -text "html"
pack .type.label .type.all .type.htmlonly -in .type -side left

checkbutton .fullbody -variable fullbody -text "fullbody"
checkbutton .checkmodified -variable checkmodified -text "check-modified"
checkbutton .oneurl -variable oneurl -text "one url only"
checkbutton .useragent -variable useragent -text "Fake User-Agent"

#  Function:
#      execute wwgetall command
#      There is no Arguments and no return value.
proc exec_wwgetall {} {

    # If we use global variables in function, we must define variable
    # as "global".
    global cmd_wwgetall

    set cmd $cmd_wwgetall
    global proxy
    # if(strcmp($proxy,"") != 0)
    if {[string compare $proxy ""] != 0} {
    # ^                                 ^
    # you must put "^" to space because syntax of "if" is not
    # "if{expr}{command}" but also "if {expr} {command}"
	set cmd "${cmd} --proxy=$proxy"
    }
    global rootdir
    if {[string compare $rootdir ""] != 0} {
	set cmd "${cmd} --rootdir=$rootdir"
    }
    global log
    if {[string compare $log ""] != 0} {
	set cmd "${cmd} --log=$log"
    }
    global match
    if {[string compare $match ""] != 0} {
	set cmd "${cmd} --match='$match'"
    }
    global auth
    if {[string compare $auth ""] != 0} {
	set cmd "${cmd} --auth=$auth"
    }
    global fullbody
    if {$fullbody != 0} {
	set cmd "${cmd} --fullbody"
    }
    global connection
    if {$connection != 0} {
	set cmd "${cmd} --connection=$connection"
    }
    global htmlonly
    if {$htmlonly != 0} {
	set cmd "${cmd} --htmlonly"
    }
    global alltype
    if {$alltype != 0} {
	set cmd "${cmd} --alltype"
    }
    global checkmodified
    if {$checkmodified != 0} {
	set cmd "${cmd} --check-modified"
    }
    global oneurl
    if {$oneurl != 0} {
	set cmd "${cmd} -1"
    }
    global useragent
    if {$useragent != 0} {
	set cmd "${cmd} -U"
    }
    global url
    if {[string compare $url ""] != ""} {
	set cmd "${cmd} $url"
    }
    set cmd "exec $cmd > /dev/tty"
    puts "Executing '$cmd'..."
    eval $cmd
}

button .go -text "get" -command {exec_wwgetall}
# button .go -text "get" -command {exec wwgetall.pl $url > /dev/tty}
# button .exit -text "exit" -command {exit}

pack .url .proxy .rootdir .log .connection .auth .match .type .fullbody .checkmodified .oneurl .useragent .go  -fill x

set url [lindex $argv 0]
